/*
	virtualsreen V6. testprogram for large workspaces...
	by Rudolf Cornelissen 4/2003

	Note please:
	Programming C++ is not something I am very good in ATM, so if you encounter me not
	destroying or closing down objects on quitting for example, please take the nessesary
	steps yourself. Thanks.
	
	Rudolf.

*/
#include <stdio.h>
#include <be/game/WindowScreen.h>
#include <be/app/Application.h>
#include <be/interface/Screen.h>
#include <Bitmap.h>

/* Matrox driver dualhead extensions to flags */
#define DUALHEAD_OFF (0<<6)
#define DUALHEAD_CLONE (1<<6)
#define DUALHEAD_ON (2<<6)
#define DUALHEAD_SWITCH (3<<6)
#define DUALHEAD_BITS (3<<6)
#define DUALHEAD_CAPABLE (1<<8)
#define TV_BITS (3<<9)
#define TV_MON (0<<9)
#define TV_PAL (1<<9)
#define TV_NTSC (2<<9)
#define TV_CAPABLE (1<<11)

int main()
{
	bool dual = false, tv = false;
	unsigned char modeNr, outMode;
	uint virtX, virtY;
	const char *name;
	display_mode mode, orgmode;

	name = "testje";

	new BApplication("application/x.vnd.virtscreen");
	printf("VirtualScreen testapp V6\n\n");

	BScreen *myScreen = new BScreen();
	if (!myScreen->IsValid())
	{
		printf("\nCould not get handle to Bscreen, exiting...\n");
		return(B_OK);
	}

	/* save org mode */
	myScreen->GetMode(&orgmode);

menu:
	mode = orgmode;

	//show menu:
	printf("\nSelect output mode (in current refresh and colordepth):\n");
	printf("1. Singlehead (std) mode\n");
	/*
	 Note:
	 Although only one head supports a hardcursor, the modes below are included
	 anyway. It works OK, but you'll miss the mousepointer on one head of course...
	 */
	printf("2. Dualhead clone mode\n");
	printf("3. Dualhead stretch mode\n");
	printf("4. Dualhead switch mode\n");
	printf("5. Exit in original mode\n");
	printf("Option: ");
	fflush(stdin);
	do scanf("%c",&modeNr);
	while ((modeNr < '1') || (modeNr > '5'));
	modeNr -= 48;

	if (modeNr == 5)
	{
		/* reset screen to original Desktop mode */
		myScreen->SetMode(&orgmode, false);
		delete(myScreen);
		printf("\nDone! Exiting...\n");
		return B_OK;
	}

	printf("\nSelect output mode:\n");
	printf("1. monitor mode\n");
	printf("2. NTSC TVout\n");
	printf("3. PAL TVout\n");
	printf("Option: ");
	fflush(stdin);
	do scanf("%c",&outMode);
	while ((outMode < '1') || (outMode > '3'));
	outMode -= 48;

	/*
		Virtual Desktop size considerations:
		
		If the cursor goes outside of the visible part of the screen, the screen will
		start rolling until it's back on it.. The driver will step with (a multiple of)
		the step granularity the card supports:

		Primary head: 
			8bit color: 8 pixels
			16bit color: 4 pixels 
			32bit color: 2 pixels 
		this applies for MIL1 upto and including G550.

 		Secondary head (so current dualhead modes): 
			16bit color: 32 pixels
			32bit color: 16 pixels

		(BTW: Nvidia TNT1 and up (for instance) can always do single pixelsteps here!)


		You should make sure you choose a virtual width with a multiple of this
		granularity so you are actually able to scroll to the right-most part of the
		screen completely!
		The height granularity is always 1 pixel BTW, for all cards, all brands AFAIK.
	 */

	/*
		BTW: You cannot know what granularity your driver/card has. If you want to know you are
		doing an exact setup, make sure you keep the lowest bits in the step clear.
		Matrox cards do worst case steps of 32, so you would need to keep b0-4 zero at least!
		

		Note: 
		Be planned to setup a new accelerant hook to overcome this problem. AFAIK it was never
		implemented: (should be confirmed though I would say)
		
		taken from:
			BeOS R4 Graphics Driver Kit.
			(alpha release 2, 1999-03-30)
		written by:
		Trey Boudreau (AFAIK)
	
	#if NEW_FOR_R4.1
		B_GET_MOVE_DISPLAY_CONSTRAINTS  -  No feature specific data required.
		typedef status_t (*get_move_display_constraints)
			(display_mode *dm, uint32 *pixels, uint32 *lines);

		For the specified display_mode, return the smallest number of pixels the display
		can be moved in the horizontal direction and the smallest number of lines the display
		can be moved in the vertical direction.  This is essentially the granularity of the
		move_display_area() feature.
	#endif

		NOTE:
		B_GET_MOVE_DISPLAY_CONSTRAINTS _should_ get implemented, but modified like this(!):
		
		B_GET_MOVE_DISPLAY_CONSTRAINTS  -  No feature specific data required.
		typedef status_t (*get_move_display_constraints)
			(display_mode *dm, uint32 *pixels, uint32 *lines, uint32 *bytes_per_row);
		
		The function will return on for instance MIL1/2 cards, for 16bits color:
		pixels = 4;
		lines = 1;
		bytes_per_row = 128; 

		You will note that bytes_per_row granularity says that only widths can be setup in 
		pixel multiples of 64 for RGB16, while the display can be moved with 4 pixels at a time!
		
		Please understand that you can do this for example:
		Setup a mode for this card that has a virtual_width of 1000 pixels, while you are
		displaying 800x600 resolution.
		
		The drivers will do this:
		->Setup virtual_width = 1000 pixels;
		->Setup slopspace of 48 bytes (24 pixels).
		
		You can now walk through this mode (with 4 pixels per step) in exactly 250 steps total.
		
		You need to have the option to let the driver create slopspace, because the app_server
		will respect this when setting up a mode. It is required too, because if it would not 
		use that, it would be impossible to setup 800x600 in 16bit color on a MIL1/2 for example,
		because the bytes_per_row multiple is 128 here, which implies a slopspace of
		64 byte (32 pixels)!!
		(slopspace is reflected in frame_buffer_config.bytes_per_row BTW.)
		If you would setup this mode with a virtual_width of 832 pixels instead of using slopspace,
		you would see 800 pixels on your screen, but you will in fact have created a virtual
		workspace, that you can pan	through. You will notice that the 'BeOS menu' (displayed at
		the upper right corner of a workspace by default) is only partly visible upon setting the
		mode. It's generated at the _rightmost_ corner of the _virtual_ workspace after all...

		REMARK:
		If B_GET_MOVE_DISPLAY_CONSTRAINTS gets implemented in the modified way above, you will be
		able to calculate exactly what the maximum supported virtual workspace sizes are, by using
		accelerant_device_info.memory to get the amount of RAM mounted on the board.
		(subtract 4kB for a worstcase scenario hardware cursor bitmap in this RAM..)
 	 */

	printf("\nSelect virtual resolution: (actual outcome is RAM-amount dependant)\n");
	if ((modeNr == 3) || (modeNr == 4))
	{
		do
		{
			printf("virtual_width (min %d, max 65535):",mode.timing.h_display * 2);
			fflush(stdin);
			scanf("%u",&virtX);
		}
		while ((virtX < (mode.timing.h_display * ((uint)2))) || (virtX > 65535));
	}
	else
	{
		do
		{
			printf("virtual_width (min %d, max 65535):",mode.timing.h_display);
			fflush(stdin);
			scanf("%u",&virtX);
		}
		while ((virtX < mode.timing.h_display) || (virtX > 65535));
	}
	
	do
	{
		printf("virtual_height (min %d, max 65535):",mode.timing.v_display);
		fflush(stdin);
		scanf("%u",&virtY);
	}
	while ((virtY < mode.timing.v_display) || (virtY > 65535));

	mode.virtual_width = virtX;
	mode.virtual_height = virtY;
	
	/*
		Check if we have a hardcursor: 
		Videodrivers should move the display _and_ the overlay if a hardcursor is
		supported and it is operating on a virtual mode: the (open)BeOS Matrox
		driver adheres to this.
		
		This implies that if a driver does not support a hardcursor, the responsibility
		for calling MOVE_DISPLAY and CONFIGURE_OVERLAY in the driver falls to the 
		app_server. It's cursor routines should call these driverhooks now if
		appropriate.
		
		Unfortunately on R5 this functionality is still lacking in the app_server...
	 */
	myScreen->ProposeMode(&mode, &mode, &mode);
	if (mode.flags & B_HARDWARE_CURSOR)
	{
		printf("Hardware cursor is available.\n");
	}
	else
	{
		printf("No hardware cursor available: aborting program!\n");
		myScreen->SetMode(&orgmode, false);
		delete(myScreen);
		return B_OK;
	}
	printf("Virtual screen size will be set to:\nWidth %d pixels, height %d pixels\n",
		mode.virtual_width, mode.virtual_height);

	/* check if we have a dualhead and/or TVout capable card (no range checking) */
	if (mode.flags & DUALHEAD_CAPABLE)
	{
		dual = true;
		printf("Dualhead capable card with ditto mode detected\n");
	}
	else printf("Card or mode not dualhead capable.\n");
	if (mode.flags & TV_CAPABLE)
	{
		tv = true;
		printf("TVout capable card with ditto mode detected\n");
	}
	else printf("Card or mode not TVout capable.\n");

	/* the driver will automatically suppress TVout or dualhead if card not capable! */
	switch (modeNr)
	{
	case 1:
		/* std mode: nothing to do here */
		break;
	case 2:
		mode.flags &= ~DUALHEAD_BITS;
		mode.flags |= DUALHEAD_CLONE;
		break;
	case 3:
		mode.flags &= ~DUALHEAD_BITS;
		mode.flags |= DUALHEAD_ON;
		break;
	case 4:
		mode.flags &= ~DUALHEAD_BITS;
		mode.flags |= DUALHEAD_SWITCH;
		break;
	}

	switch (outMode)
	{
	case 1:
		mode.flags &= ~TV_BITS;
		mode.flags |= TV_MON;
		break;
	case 2:
		mode.flags &= ~TV_BITS;
		mode.flags |= TV_NTSC;
		break;
	case 3:
		mode.flags &= ~TV_BITS;
		mode.flags |= TV_PAL;
		break;
	}

	if (mode.timing.v_display > mode.virtual_height)
	{
		printf("\nSorry: not enough memory available. re-displaying menu...\n");
	}
	else
	{
		myScreen->SetMode(&mode, false);
		printf("\nDone! re-displaying menu...\n");
	}
	goto menu;
}
